// Exercise 9.8 solution: Trapezoid.java
// Class Trapezoid definition

public class Trapezoid extends Quadrilateral 
{
   private double height; // height of trapezoid

   // eight-argument constructor
   public Trapezoid( Point first, Point second, Point third, Point fourth )
   {
      super( first, second, third, fourth );
   } // end of eight-argument Trapezoid constructor 

   // return height
   public double getHeight()
   {
      if ( getPoint1().getY() == getPoint2().getY() )
         return Math.abs( getPoint2().getY() - getPoint3().getY() );
      else
         return Math.abs( getPoint1().getY() - getPoint2().getY() );
   } // end method getHeight

   // return area
   public double getArea()
   {
      return getSumOfTwoSides() * getHeight() / 2.0;
   } // end method getArea

   // return the sum of the trapezoid's two sides
   public double getSumOfTwoSides()
   {
      if ( getPoint1().getY() == getPoint2().getY() )
         return Math.abs( getPoint1().getX() - getPoint2().getX() ) + 
            Math.abs( getPoint3().getX() - getPoint4().getX() );
      else
         return Math.abs( getPoint2().getX() - getPoint3().getX() ) +
            Math.abs( getPoint4().getX() - getPoint1().getX() );
   } // end method getSumOfTwoSides

   // return string representation of Trapezoid object
   public String toString()
   {
      return String.format( "\n%s:\n%s%s: %s\n%s: %s\n", 
         "Coordinates of Trapezoid are", getCoordinatesAsString(), 
         "Height is", getHeight(), "Area is", getArea() );
   } // end method toString
} // end class Trapezoid

/**************************************************************************
 * (C) Copyright 1992-2008 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/